#include <X11/Xlib.h>

#include <stdio.h>
//#include <string.h>
/* needed for getenv */
#include <stdlib.h>
#include <X11/X.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

#include <png.h>


#include <gdk/gdkx.h>
#include <gdk-pixbuf/gdk-pixbuf.h>



        GdkPixbuf *im ;

    GdkPixmap             *pixmap,*mask, *tmap;




int fitimage( char *thefile , char *colour );
int stretchimage( char *thefile );
int tileimage( char *thefile );
int centerimage( char *thefile , char *colour );
int coloronly( char *colour );
char *strrepl(char *Str, size_t BufSiz, char *OldStr, char *NewStr);


Display            *disp;
Visual             *vis;
int                 depth;
XSetWindowAttributes attr;
//ImlibImage *image;
//ImlibData *id;
Window              win;
//GC g;
int screen;

	
	
static void
updateProperty(dpy, w, name, type, format, data, nelem)
     Display	*dpy;
     Window	w;
     char	*name;
     Atom	type;
     int	format;
     int	data;
     int	nelem;
{
  /* intern the property name */
  Atom	atom = XInternAtom(dpy, name, 0);

  /* create or replace the property */
  XChangeProperty(dpy, w, atom, type, format, PropModeReplace, 
		  (unsigned char *)&data, nelem);
}



#include "fitimage.c"
#include "stretchimage.c"
#include "tileimage.c"
#include "centerimage.c"
#include "coloronly.c"


int main(int argc, char **argv) {
//	gtk_init (&argc, &argv);
    gdk_init(&argc,&argv);
    gdk_rgb_init();

//gdk_pixbuf_xlib_init (disp, screen);

//    gdk_imlib_init();



 char *option = "-fit";

 char *thefile;


 char *color = "rgb:00/00/00";

        if ( argc == 1 ){
          return 1;
        }
        if ( argc > 4 ){
          return 1;
        }

 printf("test: %s\n" ,argv[2]);

if ( argc == 2 ){
  thefile = argv[1];
 
}else{
  if(! strcmp(argv[1] , "-color")){
        if ( argc == 3 ){
          option = argv[1]; 
          color = argv[2];  // example:  "rgb:00/ff/00"
        }
  }else{
        option = argv[1]; 
        thefile = argv[2]; 
        if ( argc == 4 ){
          color = argv[3];  // example:  "rgb:00/ff/00"
        }
  }
}
   const char         *display_name = getenv("DISPLAY");
   if (display_name == NULL)
       display_name = ":0";
   disp = XOpenDisplay(display_name);
   if (disp == NULL)
     {
       fprintf(stderr, "Can't open display %s\n", display_name);
       return 1;
     }
XSync(disp,1);
    screen=DefaultScreen(disp);
    vis = DefaultVisual(disp, screen);
    depth = DefaultDepth(disp, screen);
//    id=Imlib_init(disp);
    attr.override_redirect=True;
    win=DefaultRootWindow(disp);
 
char roxpic[1024];
sprintf(roxpic , "%s" , "/root/Choices/ROX-background.jpg");




 printf("option: %s\n" ,option);
 
  if(! strcmp(option , "-fit")){
    while(strstr(color,"rgb:"))strrepl(color,1024,"rgb:","");
    while(strstr(color,"/"))strrepl(color,1024,"/","");
     fitimage( thefile , color );
  }

  if(! strcmp(option , "-stretch")){

     stretchimage(thefile);
  }

  if(! strcmp(option , "-tile")){

     tileimage(thefile);
  }

  if(! strcmp(option , "-center")){
    while(strstr(color,"rgb:"))strrepl(color,1024,"rgb:","");
    while(strstr(color,"/"))strrepl(color,1024,"/","");
     centerimage( thefile , color );
  }

  if(! strcmp(option , "-color")){
    while(strstr(color,"rgb:"))strrepl(color,1024,"rgb:","");
    while(strstr(color,"/"))strrepl(color,1024,"/","");
     coloronly( color );
  }


#define RETAIN_PROP_NAME	"_XSETROOT_ID"
  Pixmap pm= XCreatePixmap(disp, win, 1, 1, 1);
  updateProperty(disp, win, RETAIN_PROP_NAME, XA_PIXMAP, 32, (int)pm, 1);
  XSetCloseDownMode(disp, RetainPermanent);

	FILE *roxFile;
	FILE *jpgFile;
        char configuration[1024];
        char jpgname[1024];
	sprintf(configuration,"/usr/local/Puppybackground/resource/roxrestart.sh");
	sprintf(jpgname,roxpic);
	if ((roxFile = fopen(configuration, "r")) != NULL)
	{
          fclose(roxFile);
im=gdk_pixbuf_get_from_drawable (0,pixmap,gdk_colormap_get_system() ,0,0,0,0,XDisplayWidth(disp,screen),XDisplayHeight(disp,screen));

//          jpgFile = fopen(jpgname, "w");
//          gdk_pixbuf_png_image_save (jpgFile , im);
//          fclose(jpgFile);

/*
    int screenWidth=0;
    int screenHeight=0;

    screenWidth=XDisplayWidth(disp,screen);
    screenHeight=XDisplayHeight(disp,screen);
gint zoom_quality = (gint)GDK_INTERP_HYPER;
//im = gdk_pixbuf_scale_simple(im, screenWidth*2, screenHeight*2 , (GdkInterpType)zoom_quality);

im = gdk_pixbuf_scale_simple(im, 1280, 1024 , (GdkInterpType)zoom_quality);


im=gdk_pixbuf_add_alpha(im,1,255,0,255);

*/

gdk_pixbuf_save ( im , "/root/Choices/ROX-background.jpg" , "jpeg" ,NULL, NULL);
          gdk_pixbuf_unref(im);
	}


XSync(disp,0);
  XFlush(disp);
  XCloseDisplay(disp);
  return 0;

}

char *strrepl(char *Str, size_t BufSiz, char *OldStr, char *NewStr)
{
      int OldLen, NewLen;
      char *p, *q;

      if(NULL == (p = strstr(Str, OldStr)))
            return Str;
      OldLen = strlen(OldStr);
      NewLen = strlen(NewStr);
      if ((strlen(Str) + NewLen - OldLen + 1) > BufSiz)
            return NULL;
      memmove(q = p+NewLen, p+OldLen, strlen(p+OldLen)+1);
      memcpy(p, NewStr, NewLen);
      return q;
}

