#include <gdk/gdkx.h>	/* Needed for pixmap loading. */
#include <gtk/gtk.h>
#include <stdio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#include <string.h>
#include <stdlib.h>

GdkBitmap	*mask;  
GtkWidget *pixmapwid;

int iconcounter=0;
int buttoncounter1=0;
int buttoncounter2=0;

char selected[1024];
char mycmd[1024];	
char *configrc;
char *buttonrc1;
char *buttonrc2;
char *listrc;
char chosenfile[1024];
   GtkWidget *filew;
    int myselection = 0;
int fselectok=0;

char thedir[2048];

	GtkWidget *win;
	GtkWidget *toplevel;
	GtkWidget *clist;
	GtkWidget *mainbox;
	GtkWidget *hbox;
	GtkWidget *button;
	GtkWidget *b1box;
	GtkWidget *b2box;



void parseBaseConfigFile( char *thefile);
void parseButtonFile1( char *thefile);
void parseButtonFile2(char *thefile);
void parseListConfigFile( char *thefile);
void addButton1();
void addButton2();
void fselect();
char *dirname(char *entry);

char *strrepl(char *Str, size_t BufSiz, char *OldStr, char *NewStr);



struct{

  char picname[1024];
  char shortpicname[1024];
  GdkPixbuf *ipixbuf;

} action[1000];

struct{

  char title[1024];
  char picname[1024];
  char command[1024];
  GdkPixbuf *ipixbuf;

} buttons1[30];

struct{

  char title[1024];
  char picname[1024];
  char command[1024];
  GdkPixbuf *ipixbuf;

} buttons2[30];

  int windowwidth;
  int windowheight;
  int windowx;
  int windowy;
  char title[1000];
  int buttonbar1;
  char buttonbar1text[100];
  int buttonbar2;
  char buttonbar2text[100];
  int cellwidth;
  int cellheight;
  char cell1title[1024];
  char cell2title[1024];


GtkButton *button1[30];
GtkButton *button2[30];



static gint HandleCloseCB(
	GtkWidget *widget, gpointer *event, gpointer data
)
{
	/* Make it simple, when one window closes we just effectively
	 * close them all by breaking out of the last GTK+ main loop
	 * so that they will all be destroyed.
	 */
	gtk_main_quit();

        return(TRUE);
}

static void CListSelectRowCB(
        GtkWidget *widget,
        gint row, gint column,
        GdkEventButton *event, gpointer data
);
static void CListSelectRowCB(
	GtkWidget *widget,
	gint row, gint column,
        GdkEventButton *event, gpointer data
)
{


	/* Selected row in bounds? */
	if((row >= 0) && (row < GTK_CLIST(clist)->rows))
	{
sprintf(selected , "%s" , action[row].picname);


		/* If the selected row is not fully visible, attempt to
		 * scroll and make it visible in the center of the
		 * list.
		 */
		if(gtk_clist_row_is_visible(GTK_CLIST(clist), row) !=
			GTK_VISIBILITY_FULL
		)
			gtk_clist_moveto(
				GTK_CLIST(clist),
				row, 0,		/* Row, column. */
				0.5, 0.0	/* Row, column. */
			);
	}
}

 ////////////////////////////////////////////////////////////////////////////////////////////
//	Creates a new window with everything set up.
  ////////////////////////////////////////////////////////////////////////////////////////////
void WindowNew(const gchar *title)
{
	gchar *heading[2];

	GtkWidget *w, *parent, *scrolled_window;

	/* Create toplevel. */
        win = gtk_window_new(GTK_WINDOW_TOPLEVEL);

        gtk_signal_connect(
            GTK_OBJECT(win), "delete_event",
            GTK_SIGNAL_FUNC(HandleCloseCB), win
        );


	gtk_widget_set_usize(win, windowwidth, windowheight);
        gtk_widget_set_uposition(win, windowx,windowy );
        gtk_window_set_title(
	    GTK_WINDOW(win),
	    (title == NULL) ? "Untitled" : title
	);



        w = gtk_vbox_new(FALSE, 0);
        gtk_container_add(GTK_CONTAINER(win), w);
        gtk_widget_show(w);
	mainbox = w;

        w = gtk_hbox_new(FALSE, 0);
        gtk_box_pack_start(GTK_BOX(mainbox), w, TRUE, TRUE, 4);

        gtk_widget_show(w);
	hbox = w;
        parent = w;

	/* Create the scrolled window for the clist and the clist
	 * itself.
	 */
	scrolled_window = gtk_scrolled_window_new(NULL, NULL);
	gtk_box_pack_start(GTK_BOX(parent), scrolled_window, TRUE, TRUE, 4);
	gtk_scrolled_window_set_policy(
		GTK_SCROLLED_WINDOW (scrolled_window),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC
	);
	gtk_widget_show(scrolled_window);


	heading[0] = cell1title;
	heading[1] = cell2title;
	clist = gtk_clist_new_with_titles(2, heading);

	gtk_clist_set_selection_mode(GTK_CLIST(clist), GTK_SELECTION_SINGLE);
	gtk_clist_set_shadow_type(GTK_CLIST(clist), GTK_SHADOW_IN);
	gtk_clist_column_titles_passive(GTK_CLIST(clist));
        gtk_clist_set_column_justification(
            GTK_CLIST(clist), 0, GTK_JUSTIFY_LEFT
        );
        gtk_clist_set_column_justification(
            GTK_CLIST(clist), 1, GTK_JUSTIFY_LEFT
        );
        gtk_clist_set_row_height(GTK_CLIST(clist), cellheight);

        gtk_clist_set_column_width (GTK_CLIST(clist), 0, cellwidth);

	gtk_signal_connect(
		GTK_OBJECT(clist), "select_row",
		GTK_SIGNAL_FUNC(CListSelectRowCB), win
	);

	gtk_container_add(GTK_CONTAINER(scrolled_window), clist);
	gtk_widget_realize(clist);
	gtk_widget_show(clist);

// -- buttonbox --

if( buttonbar1 == 1 ){
        w = gtk_vbox_new(FALSE, 0);
        gtk_box_pack_start(GTK_BOX(hbox), w,FALSE , TRUE, 4);
        gtk_widget_show(w);
	b1box = w;
}
if( buttonbar2 == 1 ){
        w = gtk_hbox_new(TRUE, 0);
        gtk_box_pack_start(GTK_BOX(mainbox), w,  FALSE,  FALSE, 0); 
        gtk_widget_show(w);
	b2box = w;

}

	/* Now show the toplevel. */
	gtk_widget_show(win);

}


 ////////////////////////////////////////////////////////////////////////////////////////////
// 	Dealloactes the given window and all its resources.
 ////////////////////////////////////////////////////////////////////////////////////////////
static void WindowDelete()
{
		gtk_widget_destroy(clist);
		gtk_widget_destroy(win);
}

  //////////////////////////////////////////////////////////////
//    main
  //////////////////////////////////////////////////////////////

int main(int argc, char **argv)
{
	GtkStyle *style;
	GdkWindow *window;

	gtk_init(&argc, &argv);

	style = gtk_widget_get_default_style();
	window = (GdkWindow *)GDK_ROOT_PARENT();


        configrc = argv[1];
        buttonrc1 = argv[2];
        buttonrc2 = argv[3];
        listrc = argv[4];

        parseBaseConfigFile(configrc);

	WindowNew( title );

  /* Add a timeout to update the display once a second */
//  gtk_timeout_add ( 1000, timeout_handler , NULL );

        if(buttonbar1 == 1){
          parseButtonFile1( buttonrc1 );
        }
        if(buttonbar2 == 1){
          parseButtonFile2( buttonrc2 );
        }

        parseListConfigFile( listrc );

	/* Enter main gtk loop. */
	gtk_main();


	/* Application now shutting down, begin deallocating
	 * resources.
	 */
	WindowDelete( win );

	return(0);
}

void parseBaseConfigFile(char *thefile)
{
	FILE *configFile;
	char token[1024];
        char theline[1024];

  //////////////////////////////////////////////////////////////
 // sprintf(configuration,"config.rc");



	if ((configFile = fopen(thefile, "r")) == NULL)
	{
		fprintf(stderr, "\ndnd: Could not locate or open the config file (%s).. Giving up.\n\n",thefile);
		exit(1);
	}
	while(fscanf(configFile,"%s",token)!=EOF) 
	{
           // printf("%s\n" , token);

            strrepl(token,1024,"width","");
            windowwidth=atoi(token);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"height","");
             windowheight=atoi(theline);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"x","");
             windowx=atoi(theline);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"y","");
             windowy=atoi(theline);

             fscanf(configFile,"%s",&theline);
             while(strstr(theline,"#"))strrepl(theline,1024,"#"," ");
             strrepl(theline,1024,"title","");
             strcpy(title , theline);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"buttonsright","");
             buttonbar1 = atoi(theline);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"buttonsrighttext","");
             strcpy(buttonbar1text , theline);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"buttonsbottom","");
             buttonbar2 = atoi(theline);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"buttonsbottomtext","");
             strcpy(buttonbar2text , theline);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"cellwidth","");
             cellwidth=atoi(theline);

             fscanf(configFile,"%s",&theline);
             strrepl(theline,1024,"cellheight","");
             cellheight=atoi(theline);

             fscanf(configFile,"%s",&theline);
             while(strstr(theline,"#"))strrepl(theline,1024,"#"," ");
             strrepl(theline,1024,"cell1title","");
             strcpy(cell1title , theline);
             strcat(cell1title , "  ");
             fscanf(configFile,"%s",&theline);
             while(strstr(theline,"#"))strrepl(theline,1024,"#"," ");
             strrepl(theline,1024,"cell2title","");
             strcpy(cell2title , theline);
             strcat(cell2title , "  ");
	}

    fclose(configFile);


}

void parseListConfigFile( char *thefile )
{



	FILE *configFile;
	char token[1024];
        char theline[1024];

        char cmdname[1024];
gtk_clist_clear( GTK_CLIST(clist) );
        int x=0;
        int y=0;
        int xs=0;
        int ys=0;

        GdkPixbuf *pixbuf;
	GdkPixmap	*pixmap;

	gint new_row;
	gchar *text[2];
        text[0] = "";
        text[1] = "";
       
       iconcounter = 0;
       memset(&action,0,sizeof(action));  

  //////////////////////////////////////////////////////////////
//  read the list icons.rc
  //////////////////////////////////////////////////////////////

	if ((configFile = fopen(thefile, "r")) == NULL)
	{
		fprintf(stderr, "\ndnd: Could not locate or open the config file (%s).. Giving up.\n\n",thefile);
		exit(1);
	}
	while(fscanf(configFile,"%s",token)!=EOF) 
	{

                if(strlen(token) > 3){
//test                        action[iconcounter].ipixbuf = gdk_pixbuf_new_from_file (token);
                        action[iconcounter].ipixbuf = gdk_pixbuf_new_from_file (token,0);
       	                gdk_pixbuf_render_pixmap_and_mask(action[iconcounter].ipixbuf, &pixmap, &mask, 128);
                        sprintf(action[iconcounter].picname ,"%s", token);

			new_row = gtk_clist_append( GTK_CLIST(clist) , text );

                   	
                        fscanf(configFile,"%s",&theline);
                        while(strstr(theline,"#pbdbgspace#"))strrepl(theline,1024,"#pbdbgspace#"," ");
                       strcpy(action[iconcounter].shortpicname , theline);


                        gtk_clist_set_text(
                                GTK_CLIST(clist), new_row, 1,
                                action[iconcounter].shortpicname
                        );

                        gtk_clist_set_pixmap(
                                GTK_CLIST(clist), new_row, 0,
				pixmap, mask
                        );


                        iconcounter += 1;
                  }
	}
    fclose(configFile);
}




void parseButtonFile1( char *thefile )
{
	FILE *configFile;
  	char token[1024];
        char theline[1024];
       
  //////////////////////////////////////////////////////////////
//  read the buttonconfiguration buttons1.rc
  //////////////////////////////////////////////////////////////

	if ((configFile = fopen(thefile, "r")) == NULL)
	{
		fprintf(stderr, "\ndnd: Could not locate or open the config file (%s).. Giving up.\n\n",thefile);
		exit(1);
	}
	while(fscanf(configFile,"%s",token)!=EOF) 
	{

            while(strstr(token,"#"))strrepl(token,1024,"#"," ");
            strcpy(buttons1[buttoncounter1].title , token);


            fscanf(configFile,"%s",&buttons1[buttoncounter1].picname);

            fscanf(configFile,"%s",&theline);
            while(strstr(theline,"#"))strrepl(theline,1024,"#"," ");
            strcpy(buttons1[buttoncounter1].command , theline);

            addButton1(win);
            buttoncounter1 += 1;
	}

    fclose(configFile);

}


void parseButtonFile2( char *thefile )
{
	FILE *configFile;
  	char token[1024];
        char theline[1024];
       
  //////////////////////////////////////////////////////////////
//  read the buttonconfiguration buttons2.rc
  //////////////////////////////////////////////////////////////

	if ((configFile = fopen(thefile, "r")) == NULL)
	{
		fprintf(stderr, "\ndnd: Could not locate or open the config file (%s).. Giving up.\n\n",thefile);
		exit(1);
	}
	while(fscanf(configFile,"%s",token)!=EOF) 
	{

            while(strstr(token,"#"))strrepl(token,1024,"#"," ");
            strcpy(buttons2[buttoncounter2].title , token);


            fscanf(configFile,"%s",&buttons2[buttoncounter2].picname);

            fscanf(configFile,"%s",&theline);
            while(strstr(theline,"#"))strrepl(theline,1024,"#"," ");
            strcpy(buttons2[buttoncounter2].command , theline);

            addButton2(win);
            buttoncounter2 += 1;
	}

    fclose(configFile);

}

void buttons1_click( GtkWidget *widget, GdkEventButton *event, gpointer data )
{
    myselection = 0;
    int ic = 0;
    char reload[1024];
    char newfolder[1024];

    for(ic=0;ic<buttoncounter1;ic++){
      if ( GTK_BUTTON(widget) == button1[ic]){
        myselection = ic;
      }
    }


    strncpy( reload , buttons1[myselection].command , 10 );

    if(  strstr( reload , "reload" )){

    FILE *configFile;
    char lastfolder[1024];

    if ((configFile = fopen("last.folder", "r")) != NULL){

            fscanf(configFile,"%s",&lastfolder);
            while(strstr(lastfolder,"#pbdbgspace#"))strrepl(lastfolder,1024 , "#pbdbgspace#" , " ");
            strcpy( newfolder , lastfolder );
            fclose(configFile);
    }else{
            strcpy( newfolder , "." );
    }

      sprintf(mycmd , "%s \"%s\"" , buttons1[myselection].command , newfolder);
      strrepl(mycmd,1024,"reload","");
      printf("reload: %s\n" , mycmd);
      system(mycmd);
      parseListConfigFile( listrc );

      free(lastfolder);
      return;
    }


    if(  strstr( reload , "reloadf" )){

      sprintf(chosenfile , "%s" , "");
      fselect(win);
      return;
    }

    if(! strcmp(buttons1[myselection].command , "exit")){

      gtk_main_quit();
      return;
    }
    sprintf(mycmd , "%s \"%s\" &" , buttons1[myselection].command , selected);
    system(mycmd);

}


void buttons2_click( GtkWidget *widget, GdkEventButton *event, gpointer data )
{
    myselection = 0;
    int ic = 0;
    char reload[1024];
//    char *newfolder;

    char newfolder[1024];

    for(ic=0;ic<buttoncounter2;ic++){
      if ( GTK_BUTTON(widget) == button2[ic]){
        myselection = ic;
      }
    }


    strncpy( reload , buttons2[myselection].command , 10 );

    if(  strstr( reload , "reload" )){

    FILE *configFile;
    char lastfolder[1024];

    if ((configFile = fopen("last.folder", "r")) != NULL){

            fscanf(configFile,"%s",&lastfolder);
            while(strstr(lastfolder,"#pbdbgspace#"))strrepl(lastfolder,1024 , "#pbdbgspace#" , " ");
            strcpy( newfolder , lastfolder );
            fclose(configFile);
    }else{
            strcpy( newfolder , "." );
    }

      sprintf(mycmd , "%s \"%s\"" , buttons2[myselection].command , newfolder);
      strrepl(mycmd,1024,"reload","");
      printf("reload: %s\n" , mycmd);
      system(mycmd);
      parseListConfigFile( listrc );

      free(lastfolder);
      return;
    }


    if(  strstr( reload , "reloadf" )){

      sprintf(chosenfile , "%s" , "");
      fselect(win);
      return;
    }

    strncpy( reload , buttons2[myselection].command , 4 );

    if(  strstr( reload , "exit" )){
      sprintf(mycmd , "%s &" , buttons2[myselection].command );
      strrepl(mycmd,1024,"exit","");
      printf("reload: %s\n" , mycmd);
      system(mycmd);
      gtk_main_quit();
      return;
    }
    sprintf(mycmd , "%s \"%s\" &" , buttons2[myselection].command , selected);
    system(mycmd);
}

void addButton1(){
        GtkWidget *w;
        GtkWidget *bbox;
        bbox = b1box;
        GdkPixbuf *pixbuf;
	GdkPixmap	*pixmap;

        GtkWidget *label;
        GtkWidget *label2;
        GtkWidget *label3;
        GtkWidget *vbox;


       w = gtk_button_new();
       gtk_signal_connect (GTK_OBJECT (w), "button_press_event",
                        GTK_SIGNAL_FUNC (buttons1_click), win);

	button1[buttoncounter1]= GTK_BUTTON(w);
//test         pixbuf = gdk_pixbuf_new_from_file (buttons1[buttoncounter1].picname);
         pixbuf = gdk_pixbuf_new_from_file (buttons1[buttoncounter1].picname,0);
       	gdk_pixbuf_render_pixmap_and_mask(pixbuf, &pixmap, &mask, 128);
        pixmapwid = gtk_pixmap_new( pixmap, mask );
        gtk_widget_show( pixmapwid );

        label=gtk_label_new(buttons1[buttoncounter1].title);
	gtk_widget_show(label);

if(!strcmp(buttonbar1text , "right")){
        vbox = gtk_hbox_new(FALSE, 0);

        label2=gtk_label_new(" ");
	gtk_widget_show(label2);
        label3=gtk_label_new(" ");
	gtk_widget_show(label3);

        gtk_box_set_spacing(GTK_BOX(vbox) , 10);

	gtk_box_pack_start(GTK_BOX(vbox), label2 , 1 , 1 , 0);
	gtk_box_pack_start(GTK_BOX(vbox), pixmapwid ,0 , 0 , 0);
	gtk_box_pack_start(GTK_BOX(vbox), label , 0 , 0 , 0);
	gtk_box_pack_start(GTK_BOX(vbox), label3 , 1 , 1 , 0);

}else{
        vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), pixmapwid ,0 , 0 , 0);
	gtk_box_pack_start(GTK_BOX(vbox), label , 0 , 0 , 0);

}
        gtk_widget_show(vbox);
        gtk_container_add( GTK_CONTAINER(button1[buttoncounter1]), vbox );
	button = w;
	gtk_box_pack_start(GTK_BOX(bbox), w, FALSE, FALSE, 2);

	gtk_widget_show(w);
}


void addButton2(){
        GtkWidget *w;
        GtkWidget *bbox;
        bbox = b2box;
        GdkPixbuf *pixbuf;
	GdkPixmap	*pixmap;

        GtkWidget *label;
        GtkWidget *label2;
        GtkWidget *label3;
        GtkWidget *vbox;


       w = gtk_button_new();
       gtk_signal_connect (GTK_OBJECT (w), "button_press_event",
                        GTK_SIGNAL_FUNC (buttons2_click), win);

	button2[buttoncounter2]= GTK_BUTTON(w);
//test        pixbuf = gdk_pixbuf_new_from_file (buttons2[buttoncounter2].picname);
        pixbuf = gdk_pixbuf_new_from_file (buttons2[buttoncounter2].picname,0);
       	gdk_pixbuf_render_pixmap_and_mask(pixbuf, &pixmap, &mask, 128);
        pixmapwid = gtk_pixmap_new( pixmap, mask );
        gtk_widget_show( pixmapwid );

        label=gtk_label_new(buttons2[buttoncounter2].title);
	gtk_widget_show(label);

if(!strcmp(buttonbar2text , "right")){
        vbox = gtk_hbox_new(FALSE, 0);

        label2=gtk_label_new(" ");
	gtk_widget_show(label2);
        label3=gtk_label_new(" ");
	gtk_widget_show(label3);

        gtk_box_set_spacing(GTK_BOX(vbox) , 10);

	gtk_box_pack_start(GTK_BOX(vbox), label2 , 1 , 1 , 0);
	gtk_box_pack_start(GTK_BOX(vbox), pixmapwid ,0 , 0 , 0);
	gtk_box_pack_start(GTK_BOX(vbox), label , 0 , 0 , 0);
	gtk_box_pack_start(GTK_BOX(vbox), label3 , 1 , 1 , 0);

}else{
        vbox = gtk_vbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), pixmapwid ,0 , 0 , 0);
	gtk_box_pack_start(GTK_BOX(vbox), label , 0 , 0 , 0);

}
        gtk_widget_show(vbox);
        gtk_container_add( GTK_CONTAINER(button2[buttoncounter2]), vbox );
	button = w;
	gtk_box_pack_start(GTK_BOX(bbox), w, FALSE, TRUE, 0);
	gtk_widget_show(w);
}



char *strrepl(char *Str, size_t BufSiz, char *OldStr, char *NewStr)
{
      int OldLen, NewLen;
      char *p, *q;

      if(NULL == (p = strstr(Str, OldStr)))
            return Str;
      OldLen = strlen(OldStr);
      NewLen = strlen(NewStr);
      if ((strlen(Str) + NewLen - OldLen + 1) > BufSiz)
            return NULL;
      memmove(q = p+NewLen, p+OldLen, strlen(p+OldLen)+1);
      memcpy(p, NewStr, NewLen);
      return q;
}

void destroyfs(  )
{
  gtk_widget_destroy(filew);
}

void file_ok_sel( GtkWidget *w, GtkFileSelection *fs )
{

  char *newfolder;

  sprintf(chosenfile , "%s/*" , gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
    gtk_window_set_modal( GTK_WINDOW( GTK_WINDOW(filew) ), 0);
//destroyfs(  );
    gtk_widget_hide(filew);
    gtk_widget_destroy(filew);


      if ( strstr( chosenfile , "/") ){

printf("fs1: %s\n" , chosenfile);

   newfolder = dirname( chosenfile );
printf("fs3: %s\n" , chosenfile);

   sprintf( chosenfile , "%s" , newfolder );

    sprintf(mycmd , "%s \"%s\"" , buttons2[myselection].command , chosenfile);
    while(strstr(chosenfile," "))strrepl(chosenfile,1024, " " , "#pbdbgspace#");
    FILE *configFile;
    if ((configFile = fopen("last.folder", "w")) != NULL){
            fprintf(configFile,"%s",chosenfile);
            fclose(configFile);
    }
        sprintf(mycmd , "%s \"%s\"" , buttons2[myselection].command , chosenfile);
        strrepl(mycmd,1024,"reloadf","");
         //printf("reload: %s\n" , mycmd);
        system(mycmd);
        parseListConfigFile( listrc );
      }
printf("fs2: %s\n" , chosenfile);
}

void destroy( GtkWidget *widget,
              gpointer   data )
{
  gtk_widget_destroy(widget);
}


void fselect() {
  // GtkWidget *filew;

    filew = gtk_file_selection_new ("Folder selection");

    gtk_window_set_modal( GTK_WINDOW(filew ), 1);

    gtk_signal_connect (GTK_OBJECT (filew), "destroy",
                        (GtkSignalFunc) destroy, &filew);

    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
                        "clicked", (GtkSignalFunc) file_ok_sel, filew);
 
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
                                            (filew)->cancel_button),
                               "clicked", (GtkSignalFunc) gtk_widget_destroy,
                               GTK_OBJECT (filew));

    FILE *configFile;
    char lastfolder[1024];

    if ((configFile = fopen("last.folder", "r")) != NULL){

            fscanf(configFile,"%s",&lastfolder);
            while(strstr(lastfolder,"#pbdbgspace#"))strrepl(lastfolder,1024 , "#pbdbgspace#" , " ");
            gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew),  lastfolder);
            fclose(configFile);
    }
    
    gtk_widget_show(filew );

}

char *dirname(char *entry){

  int laenge;
  int laenge2;
  laenge = strlen( entry );

  strcpy( thedir , "" );
  gchar *rest;

  rest = strrchr( entry , '/' );
  laenge2 =  strlen( rest );

  if( laenge2 > 1 ){
    strncat ( thedir , entry , laenge - laenge2+1 );
  }else{
    strncat ( thedir , entry , laenge );
  }
    printf("---%s\n" , thedir);
    //printf("laenge: %d\n" , laenge);
    //printf("laenge2: %d\n" , laenge2);
    //printf("dirname3: %s\n" , entry);
  return thedir;
}
